' Copyright Hewlett-Packard 1984, 1985, 1989
'
'  Set up program for MS-DOS HP-IB I/O Library
'  For use with QuickBASIC by Microsoft
'
'  COMMON declarations are needed if your program is going to chain
'    to other programs.  When chaining, be sure to call DEFERR as
'    well upon entering the chained-to program
'
DECLARE SUB IOABORT    (ISC&)
DECLARE SUB IOCLEAR    (ISC&)
DECLARE SUB IOCONTROL  (ISC&, COND%, STAT%)
DECLARE SUB IODMA      (ISC&, COUNT%, CHANNEL%)
DECLARE SUB IOENTER    (ISC&, NUMBER!)
DECLARE SUB IOENTERA   (ISC&, SEG NUMBER!, COUNT%, COUNT2%)
DECLARE SUB IOENTERAB  (ISC&, SEG NUM AS ANY, COUNT%, COUNT2%, SWP%)
DECLARE SUB IOENTERB   (ISC&, SEG NUM AS ANY, COUNT%, COUNT2%, SWP%)
DECLARE SUB IOENTERF   (ISC&, FILE.NAME$, COUNT&, FLAG%)
DECLARE SUB IOENTERS   (ISC&, STRN$, COUNT%, COUNT2%)
DECLARE SUB IOEOI      (ISC&, FLAG%)
DECLARE SUB IOEOL      (ISC&, STRN$, FLAG%)
DECLARE SUB IOFASTOUT  (ISC&, FLAG%)
DECLARE SUB IOGETTERM  (ISC&, REASON%)
DECLARE SUB IOLLOCKOUT (ISC&)
DECLARE SUB IOLOCAL    (ISC&)
DECLARE SUB IOMATCH    (ISC&, STRN$, FLAG%)
DECLARE SUB IOOUTPUT   (ISC&, NUMBER!)
DECLARE SUB IOOUTPUTA  (ISC&, SEG NUMBER!, COUNT%)
DECLARE SUB IOOUTPUTAB (ISC&, SEG NUM AS ANY, COUNT%, SWP%)
DECLARE SUB IOOUTPUTB  (ISC&, SEG NUM AS ANY, COUNT%, SWP%)
DECLARE SUB IOOUTPUTF  (ISC&, FILE.NAME$, COUNT&)
DECLARE SUB IOOUTPUTS  (ISC&, STRN$, COUNT%)
DECLARE SUB IOPASSCTL  (ISC&)
DECLARE SUB IOPEN      (ISC&, STAT%)
DECLARE SUB IOPPOLL    (ISC&, RESPONSE%)
DECLARE SUB IOPPOLLC   (ISC&, STAT%)
DECLARE SUB IOPPOLLU   (ISC&)
DECLARE SUB IOREMOTE   (ISC&)
DECLARE SUB IOREQUEST  (ISC&, STAT%)
DECLARE SUB IORESET    (ISC&)
DECLARE SUB IOSEND     (ISC&, STRN$, COUNT%)
DECLARE SUB IOSPOLL    (ISC&, RESPONSE%)
DECLARE SUB IOSTATUS   (ISC&, COND%, STAT%)
DECLARE SUB IOTAKECTL  (ISC&, STAT%)
DECLARE SUB IOTIMEOUT  (ISC&, NUMBER!)
DECLARE SUB IOTRIGGER  (ISC&)

COMMON PCIB.BASERR, PCIB.ERR, PCIB.ERR$, PCIB.NAME$, PCIB.GLBERR
COMMON FALSE%, TRUE%, NOERR, EUNKNOWN, ESEL, ERANGE, ETIME, ECTRL, EPASS
COMMON ENUM, EADDR, EFILE
'
'
'  Establish error variables and ON ERROR branching
'
PCIB.ERR = 0
PCIB.ERR$ = STRING$(64, 32)
PCIB.NAME$ = STRING$(16, 32)
PCIB.GLBERR = 0
CALL DEFERR(PCIB.ERR, PCIB.ERR$, PCIB.NAME$, PCIB.GLBERR)
PCIB.BASERR = 255
ON ERROR GOTO 99
GOTO MNEMONICS
'
'  Error handling routine
'
ERRORHANDLER:
99  IF ERR = PCIB.BASERR THEN GOTO LIBERROR
    PRINT "BASIC error #"; ERR; "occurred on line #"; ERL
    STOP

LIBERROR:
  TMPERR = PCIB.ERR
  IF TMPERR = 0 THEN TMPERR = PCIB.GLBERR
  PRINT "HP-IB error #"; TMPERR; " detected on line #"; ERL
  PRINT "Error: "; PCIB.ERR$
  STOP
'
MNEMONICS:
  FALSE% = 0
  TRUE% = NOT FALSE%
  NOERR = 0
  EUNKNOWN = 100001!
  ESEL = 100002!
  ERANGE = 100003!
  ETIME = 100004!
  ECTRL = 100005!
  EPASS = 100006!
  ENUM = 100007!
  EADDR = 100008!
  EFILE = 100009!
'
' End Program Set-up
